/*****************************************************************************
 Copyright (c) 1993, 1994 UUNET Technologies
 All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions
 are met:
 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the distribution.
 3. All advertising materials mentioning features or use of this software
    must display the following acknowledgement:
      This product includes software developed by UUNET Technologies
 4. The name UUNET Technologies may not be used to endorse or promote products  
    derived from this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY THE UUNET Technologies ``AS IS'' AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 ARE DISCLAIMED.  IN NO EVENT SHALL THE UUNET Technologies BE LIABLE
 FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 SUCH DAMAGE.

*****************************************************************************/


#include <sys/types.h>
#include <sfio.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <assert.h>
#include <malloc.h>
#include <string.h>

#include <general.h>

#include <rsaref.h>
#include <r_encode.h>

#include <keys.h>

#include <muse.h>

static unsigned char keystatus[NUMKEYS];


int readkeystatus(void)
{
  Sfile_t *ksfile;
  int status;

  ksfile = sfopen(NULL, "keystatus", "r");
  assert((status = sfread(ksfile, &keystatus, NUMKEYS)) >= 0);
  return sfclose(ksfile);
}

void setkeystatus(keyno, flags)
unsigned char keyno, flags;
{
  keystatus[keyno] = flags;
}

unsigned char getkeystatus(keyno)
int keyno;
{
  return keystatus [keyno];
}

int writekeystatus(void)
{
  Sfile_t *ksfile;
  int status;

  ksfile = sfopen(NULL, "keystatus", "w");
  assert((status = sfwrite(ksfile, &keystatus, NUMKEYS)) >= 0);
  return sfclose(ksfile);
}

